//////////////////////////////////////////////////////////////////////
//	$Date:: 2013-09-28 13:03:13 +0900#$
//	$Rev: 5692 $
//	Copyright (C) Hiroshi SUGIMURA 2013.09.27 - above.
//////////////////////////////////////////////////////////////////////
// Example testing sketch for ECHONET Lite protocol
// Written by Hiroshi SUGIMURA, public domain
#include <SPI.h>
#include <Ethernet.h>
#include <EthernetUdp.h>
#include <Udp.h>
#include <EL.h>

byte mac[] = {
  0x90, 0xA2, 0xDA, 0x0E, 0xA0, 0x50 }; // mac address


EL echo;


void setup()
{
  Serial.begin(9600);
  Serial.println("EL test!");

  Serial.println("DHCP...");
  while(1) {
    if ( Ethernet.begin(mac) == 0 ) {
      Serial.println("Failed to configure Ethernet using DHCP");
    }
    else {
      Serial.println("DHCP ok!");
      break;
    }
  }

  printNetData();

  echo.begin();

}

void loop()
{

  IPAddress t(192,168,50,3);

  uint8_t s[] = {
    0x10, 0x81, 0x00, 0x00, 0x02, 0x90, 0x01, 0x05, 0xff, 0x01, 0x74, 0x01, 0x80, 0x01, 0x30    };
  echo.send( t, s, 15 );

  delay(1000);

}




////////////////////////////////////////////////////////////////////////////////
// Net status
void printNetData() {
  Serial.println("-----------------------------------");

  // IP
  // print your WiFi shield's IP address:
  IPAddress ip = Ethernet.localIP();
  Serial.print("IP  Address: ");
  Serial.println(ip);

  IPAddress dgwip = Ethernet.gatewayIP();
  Serial.print("DGW Address: ");
  Serial.println(dgwip);

  IPAddress smip = Ethernet.subnetMask();
  Serial.print("SM  Address: ");
  Serial.println(smip);


  // print your MAC address:
  Serial.print("MAC address: ");
  Serial.print(mac[5],HEX);
  Serial.print(":");
  Serial.print(mac[4],HEX);
  Serial.print(":");
  Serial.print(mac[3],HEX);
  Serial.print(":");
  Serial.print(mac[2],HEX);
  Serial.print(":");
  Serial.print(mac[1],HEX);
  Serial.print(":");
  Serial.println(mac[0],HEX);


  Serial.println("-----------------------------------");
}

////////////////////////////////////////////////////////////////////////////////
// EOF
////////////////////////////////////////////////////////////////////////////////

